/*!
 * Copyright (c) 2012 - 2020, Anaconda, Inc., and Bokeh Contributors
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 * 
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 * 
 * Redistributions in binary form must reproduce the above copyright notice,
 * this list of conditions and the following disclaimer in the documentation
 * and/or other materials provided with the distribution.
 * 
 * Neither the name of Anaconda nor the names of any contributors
 * may be used to endorse or promote products derived from this software
 * without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
*/
(function(root, factory) {
  factory(root["Bokeh"]);
})(this, function(Bokeh) {
  var define;
  return (function(modules, entry, aliases, externals) {
    if (Bokeh != null) {
      return Bokeh.register_plugin(modules, entry, aliases, externals);
    } else {
      throw new Error("Cannot find Bokeh. You have to load it prior to loading plugins.");
    }
  })
({
"c764d38756": function _(e,o,s){Object.defineProperty(s,"__esModule",{value:!0});const t=e("tslib").__importStar(e("b4555bea44"));s.GeoViews=t,e("@bokehjs/base").register_models(t)},
"b4555bea44": function _(o,e,l){Object.defineProperty(l,"__esModule",{value:!0});var r=o("fc272d6e02");l.CheckpointTool=r.CheckpointTool;var a=o("711ab637c9");l.ClearTool=a.ClearTool;var t=o("aafc812d10");l.PolyVertexDrawTool=t.PolyVertexDrawTool;var T=o("8d03f6f592");l.PolyVertexEditTool=T.PolyVertexEditTool;var c=o("e81e0595cf");l.RestoreTool=c.RestoreTool},
"fc272d6e02": function _(o,e,t){Object.defineProperty(t,"__esModule",{value:!0});const s=o("tslib").__importStar(o("@bokehjs/core/properties")),i=o("@bokehjs/core/util/array"),c=o("@bokehjs/models/tools/actions/action_tool");class n extends c.ActionToolView{doit(){const o=this.model.sources;for(const e of o){e.buffer||(e.buffer=[]);let o={};for(const t in e.data){const s=e.data[t],c=[];for(const o of s)Array.isArray(o)||ArrayBuffer.isView(o)?c.push(i.copy(o)):c.push(o);o[t]=c}e.buffer.push(o)}}}t.CheckpointToolView=n,n.__name__="CheckpointToolView";class r extends c.ActionTool{constructor(o){super(o),this.tool_name="Checkpoint",this.icon="bk-tool-icon-save"}static init_CheckpointTool(){this.prototype.default_view=n,this.define({sources:[s.Array,[]]})}}t.CheckpointTool=r,r.__name__="CheckpointTool",r.__module__="geoviews.models.custom_tools",r.init_CheckpointTool()},
"711ab637c9": function _(o,e,t){Object.defineProperty(t,"__esModule",{value:!0});const s=o("tslib").__importStar(o("@bokehjs/core/properties")),i=o("@bokehjs/models/tools/actions/action_tool");class l extends i.ActionToolView{doit(){for(var o of this.model.sources){for(const e in o.data)o.data[e]=[];o.change.emit(),o.properties.data.change.emit()}}}t.ClearToolView=l,l.__name__="ClearToolView";class a extends i.ActionTool{constructor(o){super(o),this.tool_name="Clear data",this.icon="bk-tool-icon-reset"}static init_ClearTool(){this.prototype.type="ClearTool",this.prototype.default_view=l,this.define({sources:[s.Array,[]]})}}t.ClearTool=a,a.__name__="ClearTool",a.__module__="geoviews.models.custom_tools",a.init_ClearTool()},
"aafc812d10": function _(e,t,s){Object.defineProperty(s,"__esModule",{value:!0});const o=e("tslib").__importStar(e("@bokehjs/core/properties")),r=e("@bokehjs/core/util/object"),l=e("@bokehjs/core/util/types"),i=e("@bokehjs/models/tools/edit/poly_draw_tool");class a extends i.PolyDrawToolView{_split_path(e,t){for(let s=0;s<this.model.renderers.length;s++){const o=this.model.renderers[s],r=o.glyph,i=o.data_source,[a,d]=[r.xs.field,r.ys.field],n=i.data[a],_=i.data[d];for(let s=0;s<n.length;s++){let o=n[s];l.isArray(o)||(o=Array.from(o),i.data[a][s]=o);let r=_[s];l.isArray(r)||(r=Array.from(r),i.data[d][s]=r);for(let l=0;l<o.length;l++)if(o[l]==e&&r[l]==t&&0!=l&&l!=o.length-1){n.splice(s+1,0,o.slice(l)),_.splice(s+1,0,r.slice(l)),o.splice(l+1),r.splice(l+1);for(const e of i.columns())e!==a&&e!=d&&i.data[e].splice(s+1,0,i.data[e][s]);return}}}}_snap_to_vertex(e,t,s){if(this.model.vertex_renderer){const o=this._select_event(e,!1,[this.model.vertex_renderer]),r=this.model.vertex_renderer.data_source,l=this.model.vertex_renderer.glyph,[i,a]=[l.x.field,l.y.field];if(o.length){const o=r.selected.indices[0];i&&(t=r.data[i][o]),a&&(s=r.data[a][o]),"mousemove"!=e.type&&this._split_path(t,s),r.selection_manager.clear()}}return[t,s]}_set_vertices(e,t,s){const o=this.model.vertex_renderer.glyph,i=this.model.vertex_renderer.data_source,[a,d]=[o.x.field,o.y.field];if(a&&(l.isArray(e)?i.data[a]=e:o.x={value:e}),d&&(l.isArray(t)?i.data[d]=t:o.y={value:t}),null!=s)for(const e of r.keys(s))i.data[e]=s[e],o[e]={field:e};else for(const e of i.columns())i.data[e]=[];this._emit_cds_changes(i,!0,!0,!1)}_show_vertices(){if(!this.model.active)return;const e=[],t=[],s={};for(const e of r.keys(this.model.end_style))s[e]=[];for(let o=0;o<this.model.renderers.length;o++){const l=this.model.renderers[o],i=l.data_source,a=l.glyph,[d,n]=[a.xs.field,a.ys.field];for(const t of i.get_array(d)){Array.prototype.push.apply(e,t);for(const e of r.keys(this.model.end_style))s[e].push(this.model.end_style[e]);for(const e of r.keys(this.model.node_style))for(let o=0;o<t.length-2;o++)s[e].push(this.model.node_style[e]);for(const e of r.keys(this.model.end_style))s[e].push(this.model.end_style[e])}for(const e of i.get_array(n))Array.prototype.push.apply(t,e);if(this._drawing&&o==this.model.renderers.length-1){e.splice(e.length-1,1),t.splice(t.length-1,1);for(const e of r.keys(s))s[e].splice(s[e].length-1,1)}}this._set_vertices(e,t,s)}_remove(){const e=this.model.renderers[0],t=e.data_source,s=e.glyph,[o,r]=[s.xs.field,s.ys.field];if(o){const e=t.data[o].length-1,s=t.get_array(o)[e];s.splice(s.length-1,1),1==s.length&&t.data[o].splice(e,1)}if(r){const e=t.data[r].length-1,s=t.get_array(r)[e];s.splice(s.length-1,1),1==s.length&&t.data[r].splice(e,1)}this._emit_cds_changes(t),this._drawing=!1,this._show_vertices()}}s.PolyVertexDrawToolView=a,a.__name__="PolyVertexDrawToolView";class d extends i.PolyDrawTool{constructor(e){super(e)}static init_PolyVertexDrawTool(){this.prototype.default_view=a,this.define({end_style:[o.Any,{}],node_style:[o.Any,{}]})}}s.PolyVertexDrawTool=d,d.__name__="PolyVertexDrawTool",d.__module__="geoviews.models.custom_tools",d.init_PolyVertexDrawTool()},
"8d03f6f592": function _(e,t,s){Object.defineProperty(s,"__esModule",{value:!0});const i=e("tslib").__importStar(e("@bokehjs/core/properties")),r=e("@bokehjs/core/util/object"),o=e("@bokehjs/core/util/types"),d=e("@bokehjs/models/tools/edit/poly_edit_tool");class _ extends d.PolyEditToolView{deactivate(){this._hide_vertices(),this._selected_renderer&&(this._drawing&&(this._remove_vertex(),this._drawing=!1),this._emit_cds_changes(this._selected_renderer.data_source,!1,!0,!1))}_pan(e){if(null==this._basepoint)return;const t=this._drag_points(e,[this.model.vertex_renderer]);e.shiftKey||this._move_linked(t),this._selected_renderer&&this._selected_renderer.data_source.change.emit()}_pan_end(e){if(null==this._basepoint)return;const t=this._drag_points(e,[this.model.vertex_renderer]);e.shiftKey||this._move_linked(t),this._emit_cds_changes(this.model.vertex_renderer.data_source,!1,!0,!0),this._selected_renderer&&this._emit_cds_changes(this._selected_renderer.data_source),this._basepoint=null}_drag_points(e,t){if(null==this._basepoint)return[];const[s,i]=this._basepoint,r=[];for(const o of t){const t=this._map_drag(s,i,o),d=this._map_drag(e.sx,e.sy,o);if(null==d||null==t)continue;const[_,n]=d,[l,a]=t,[c,h]=[_-l,n-a],y=o.glyph,f=o.data_source,[u,m]=[y.x.field,y.y.field];for(const e of f.selected.indices){const t=[];u&&(t.push(f.data[u][e]),f.data[u][e]+=c),m&&(t.push(f.data[m][e]),f.data[m][e]+=h),t.push(c),t.push(h),r.push(t)}f.change.emit()}return this._basepoint=[e.sx,e.sy],r}_set_vertices(e,t,s){const i=this.model.vertex_renderer.glyph,d=this.model.vertex_renderer.data_source,[_,n]=[i.x.field,i.y.field];if(_&&(o.isArray(e)?d.data[_]=e:i.x={value:e}),n&&(o.isArray(t)?d.data[n]=t:i.y={value:t}),null!=s)for(const e of r.keys(s))d.data[e]=s[e],i[e]={field:e};else for(const e of d.columns())d.data[e]=[];this._emit_cds_changes(d,!0,!0,!1)}_move_linked(e){if(!this._selected_renderer)return;const t=this._selected_renderer,s=t.glyph,i=t.data_source,[r,o]=[s.xs.field,s.ys.field],d=i.data[r],_=i.data[o];for(const t of e){const[e,s,i,r]=t;for(let t=0;t<d.length;t++){const o=d[t],n=_[t];for(let t=0;t<o.length;t++)o[t]==e&&n[t]==s&&(o[t]+=i,n[t]+=r)}}}_tap(e){const t=this.model.vertex_renderer,s=this._map_drag(e.sx,e.sy,t);if(null==s)return;if(this._drawing&&this._selected_renderer){let[i,r]=s;const o=t.data_source,d=t.glyph,[_,n]=[d.x.field,d.y.field],l=o.selected.indices;[i,r]=this._snap_to_vertex(e,i,r);const a=l[0];if(o.selected.indices=[a+1],_){const e=o.get_array(_),t=e[a];e[a]=i,e.splice(a+1,0,t)}if(n){const e=o.get_array(n),t=e[a];e[a]=r,e.splice(a+1,0,t)}return o.change.emit(),void this._emit_cds_changes(this._selected_renderer.data_source,!0,!1,!0)}const i=e.shiftKey;this._select_event(e,i,[t])}_show_vertices(e){if(!this.model.active)return;const t=this._select_event(e,!1,this.model.renderers);if(!t.length)return this._hide_vertices(),this._selected_renderer=null,void(this._drawing=!1);const s=t[0],i=s.glyph,d=s.data_source,_=d.selected.indices[0],[n,l]=[i.xs.field,i.ys.field];let a,c;n?(a=d.data[n][_],o.isArray(a)||(d.data[n][_]=a=Array.from(a))):a=i.xs.value,l?(c=d.data[l][_],o.isArray(c)||(d.data[l][_]=c=Array.from(c))):c=i.ys.value;const h={};for(const e of r.keys(this.model.end_style))h[e]=[this.model.end_style[e]];for(const e of r.keys(this.model.node_style))for(let t=0;t<a.length-2;t++)h[e].push(this.model.node_style[e]);for(const e of r.keys(this.model.end_style))h[e].push(this.model.end_style[e]);this._selected_renderer=s,this._set_vertices(a,c,h)}}s.PolyVertexEditToolView=_,_.__name__="PolyVertexEditToolView";class n extends d.PolyEditTool{constructor(e){super(e)}static init_PolyVertexEditTool(){this.prototype.default_view=_,this.define({node_style:[i.Any,{}],end_style:[i.Any,{}]})}}s.PolyVertexEditTool=n,n.__name__="PolyVertexEditTool",n.__module__="geoviews.models.custom_tools",n.init_PolyVertexEditTool()},
"e81e0595cf": function _(o,e,t){Object.defineProperty(t,"__esModule",{value:!0});const s=o("tslib").__importStar(o("@bokehjs/core/properties")),i=o("@bokehjs/models/tools/actions/action_tool");class r extends i.ActionToolView{doit(){const o=this.model.sources;for(const e of o)e.buffer&&0!=e.buffer.length&&(e.data=e.buffer.pop(),e.change.emit(),e.properties.data.change.emit())}}t.RestoreToolView=r,r.__name__="RestoreToolView";class n extends i.ActionTool{constructor(o){super(o),this.tool_name="Restore",this.icon="bk-tool-icon-undo"}static init_RestoreTool(){this.prototype.default_view=r,this.define({sources:[s.Array,[]]})}}t.RestoreTool=n,n.__name__="RestoreTool",n.__module__="geoviews.models.custom_tools",n.init_RestoreTool()},
}, "c764d38756", {"index":"c764d38756","models/index":"b4555bea44","models/checkpoint_tool":"fc272d6e02","models/clear_tool":"711ab637c9","models/poly_draw":"aafc812d10","models/poly_edit":"8d03f6f592","models/restore_tool":"e81e0595cf"}, {});
})

